<script src="@#file#(bresenham.js)" type="text/javascript"></script>

<p>Linija u matematičkom smislu predstavlja dio pravca: vizualno nešto što je beskonačno "tanko" i kontinuirano. Na rasterskim prikaznim jedinicama takav prikaz je nemoguć: rasterska prikazna jedinica je diskretan skup slikovnih elemenata pri čemu svaki od slikovnih elemenata može biti osvijetljen ili ugašen (idemo gledati "crno/bijele" rasterske prikazne jedinice).</p>

<p>Na rasterskim prikaznim jedinicama koordinatni sustav je diskretan, koordinate su cjelobrojne i adresiraju pojedine slikovne elemente. Slikovni elementi pri tome su posloženi u dvodimenzijsku matricu zadane širine i visine (prikazna jedinica sastoji se od zadanog broja redaka slikovnih elemenata, pri čemu svaki redak ima jednak broj stupaca - jedan slikovni element, jedan stupac). Uobičajeno je u uporabi <i>ekranski koordinatni sustav</i> koji slikovnom elementu gornjem lijevom uglu matrice daje koordinate (0,0), slikovnom elementu koji je desno od njega (1,0), sljedećem desnom (2,0) itd. Prvom slikovnom elementu ispod onog u gornjem lijevom uglu dane su koordinate (0,1), slikovnom elementu ispod njega (0,2), itd. Kako su koordinate slikovnog elemenata u općem zapisu (x,y), vidimo da pozitivna x-os gleda u desno a pozitivna y-os prema dolje, s obzirom na slikovni element smješten u gornjem lijevom uglu.</p>

<p>Za potrebe razumijevanja daljnjeg teksta, moramo se dogovoriti oko još jednog detalja. U matematičkom smislu, koordinatni sustav koji razapnemo nad ravninom može imati koordinate koje su realni brojevi; tako možemo govoriti o točki čije su koordinate (1,5), ali i o točki čije su koordinate (1.34,2.58). Na rasterskoj prikaznoj jedinici to nije moguće: slikovni elementi su diskretni pa su sve koordinate cjelobrojne. U matematičkom smislu, "točka" je beskonačno "tanka"; na rasterskoj prikaznoj jedinici slikovni element ima određenu površinu (što je i razlog zašto ga vidimo). Prilikom razmatranja koja slijede, radit ćemo analizu postupaka kao da rade nad ravninom u matematičkom smislu; koordinatni sustav razapet ćemo nad rasterom na način da se točke s cjelobrojnim koordinatama nalaze točno u sredini slikovnih elemenata (vidi Sliku 1). Tako će vrijediti da, ako se od cjelobrojnih koordinata okomito ili vodoravno pokušamo pomaknuti za manje od 0.5, još uvijek ćemo ostati unutar istog slikovnog elementa. Ako se pomaknemo preko toga, upast ćemo u područje sljedećeg slikovnog elementa.</p>

<figure class="mlFigure">
<img width="431" height="421" src="@#file#(raster.svg)" alt="Raster i koordinatni sustav."><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Raster i zamišljeni idealan koordinatni sustav.</figcaption>
</figure>

<p>Na slici 1, slikovni elementi prikazani su kao bijeli kvadratići. x i y-koordinate slikovnih elemenata prikazane su iznad i lijevo od rastera. Koordinatni sustav s realnim koordinatama koji smo razapeli, prikazan je crnim linijama. Cjelobrojne koordinate tog koordinatnog sustava poklapaju se s centrima slikovnih elemenata (mali crveni kružići).</p>

<p>Idemo sada konačno pogledati kako krenuti u izradu algoritma koji crta liniju.</p>
